
#ifndef CAMPAIGN_H
#define CAMPAIGN_H

#include "stdincl.h"
#include "story_entity.h"


class World;

class Campaign : public StoryEntity {

 public:
  Campaign ();
  ~Campaign ();

  StoryEntity* currentEntity;

  virtual Error init();
  virtual Error start();
  virtual Error start(Uint32 storyID);
  virtual Error stop();
  virtual Error pause();
  virtual Error resume();

  void addEntity(StoryEntity* se, Uint32 storyID);
  void addEntity(StoryEntity* se);
  void removeEntity(Uint32 storyID);
  void removeEntity(StoryEntity* se);
  
  void nextLevel();
  void previousLevel();

 private:
  ListTemplate<StoryEntity>* entities;
  bool running;

  StoryEntity* getStoryEntity(Uint32 storyID);
};

#endif
