
#ifndef LIST_H
#define LIST_H

#include "stdincl.h"

//! An enum to list all the modes available when adding an object to a List
//enum ADDMODE {LIST_ADD_FIRST, LIST_ADD_LAST};
//! An enum to list the two searching directions available when removing an object from a List
//enum FINDMODE {LIST_FIND_BW, LIST_FIND_FW};



class WorldEntity;

class List {

 public:
  List ();
  ~List ();

  void add(WorldEntity* entity);
  void remove(WorldEntity* entity);
  void clear();
  WorldEntity* firstElement();
  bool isEmpty();
  int getSize();
  WorldEntity* enumerate();
  WorldEntity* nextElement();
  WorldEntity* toArray();
  void debug();

 private:
  struct listElement
  {
    listElement* prev;
    WorldEntity* curr;
    listElement* next;
  };
  Uint32 size;
  listElement* first;
  listElement* last;
  listElement* currentEl;


};

class Iterator
{

 public:
  bool hasNext();
  WorldEntity* next();

 private:

};

#endif
